
class Grafo:
    def __init__(self):
        self.matriz = []

    def setNodos(self, n):
        self.matriz = []
        for i in range(0,n):
            l = []
            for j in range(0,n):
                l.append(0)
            self.matriz.append(l)
        

    def cantidadNodos(self):
        return len(self.matriz)

    def conectar(self, u,v):
        assert u in range(1,self.cantidadNodos() + 1) # INTRODUCIRLO DESPUES...
        assert v in range(1,self.cantidadNodos() + 1)
        assert u!=v
        self.matriz[u-1][v-1] = True
        self.matriz[v-1][u-1] = True

    def desconectar(self,u,v):
        assert u in range(0,self.cantidadNodos())
        assert v in range(0,self.cantidadNodos())
        assert u!=v
        self.matriz[u-1][v-1] = False
        self.matriz[v-1][u-1] = False

    def conectados(self, u,v):
        return self.matriz[u-1][v-1]

    def __str__(self):
        s = "Nodos: " + str(self.cantidadNodos()) + "\n"
        for u in range(1,self.cantidadNodos() + 1):
            for v in range(1,self.cantidadNodos() + 1):
                if self.conectados(u,v):
                    s = s + " 1"
                else:
                    s = s + " 0"
            s = s + "\n"
        return s

    def devolverMatrizAdyacencia(self):
        return self.matriz

    def devolverListaIncidencia(self):
        return 0 # EJERCICIO

    def grado(self, u):
        acum = 0
        for v in range(1,self.cantidadNodos() + 1):
            if self.conectados(u,v):
                acum = acum + 1
        return (acum)

    def vecinos(self, u):
        vec = []
        for v in range(1, self.cantidadNodos()+1):
            if self.conectados(u,v):
                vec.append(v)
        return vec


def guardarGrafoEstandar(g,archivo):
    f = file(archivo, 'w')
    s = ""
    n = g.cantidadNodos()
    s = s + str(n) + "\n"
    for i in range(1,n+1):
        for j in range(i+1, n+1):
            if g.conectados(i,j):
                s = s + str(i) + " " + str(j) + "\n"
    f.write(s)
    
def cargarGrafoEstandar(archivo):
    f = file(archivo, 'r')
    g = Grafo()
    lineas = f.readlines()
    cantNodos = int(lineas[0])
    g.setNodos(cantNodos)
    for i in range(1,len(lineas)):
            tokens = str.split(lineas[i])
            g.conectar(int(tokens[0]), int(tokens[1]))
    return g

    
def cargarSolucion(archivo):
    f = file(archivo, 'r')
    linea = f.readline()
    nodosStr = str.split(linea)
    nodos = []
    for s in nodosStr:
        nodos.append(int(s))
    return nodos



# Cantidad de vecinos de v en g pero fuera de la lista A.
def vecinosExternos(g,v,A):
    vecinos = g.vecinos(v)
    accum = 0
    for w in vecinos:
        if not (w in A):
            accum = accum + 1
    return accum


# Calcula un corte con un vector numerico.
def corte(g,A):
    accum = 0
    for v in A:
        accum = accum + vecinosExternos(g,v,A)
    return accum

    
# Evaluador
def evaluarSolucion(archivoGrafo, archivoSolucion):
    g = cargarGrafoEstandar(archivoGrafo)
    s = cargarSolucion(archivoSolucion)
    print "El corte es ", corte(g,s)


# Evaluador compacto.
def tester(nombre):
    archivoGrafo = nombre + ".txt"
    archivoSolucion = "Res" + nombre + ".txt"
    evaluarSolucion(archivoGrafo, archivoSolucion)



